import jsdom from "jsdom";
import { BasicChartService } from "./chart/basicchart.service.js";
import { BarChart } from "./chart/charttypes/barchart.js";
import { GaugeChart } from "./chart/charttypes/gaugechart.js";
import { PointChart } from "./chart/charttypes/pointchart.js";
import { RadarChart } from "./chart/charttypes/radarchart.js";
import { Regression } from "./chart/charttypes/regression.js";
const { JSDOM } = jsdom;
export class Chart {
    constructor() {
        this.basicChartService = new BasicChartService();
        this.regression = new Regression();
    }
    getPointChart(config) {
        const dom = this.createDom();
        let basicChart;
        basicChart = this.basicChartService.getBasicChart(dom.window.document.body, config);
        let pointChart = new PointChart();
        pointChart.fillChart(config, basicChart);
        return dom.serialize();
    }
    getBarChart(config) {
        const dom = this.createDom();
        let basicChart;
        basicChart = this.basicChartService.getBasicChart(dom.window.document.body, config);
        let barChart = new BarChart();
        barChart.fillChart(config, basicChart);
        return dom.serialize();
    }
    getGaugeChart(config) {
        const dom = this.createDom();
        let basicChart;
        basicChart = this.basicChartService.getBasicChart(dom.window.document.body, config);
        let gaugeChart = new GaugeChart();
        gaugeChart.fillChart(config, basicChart);
        return dom.serialize();
    }
    getRadarChart(config) {
        const dom = this.createDom();
        let basicChart;
        basicChart = this.basicChartService.getBasicChart(dom.window.document.body, config);
        let radar = new RadarChart();
        radar.fillChart(config, basicChart);
        return dom.serialize();
    }
    createDom() {
        var virtualConsole = new jsdom.VirtualConsole().sendTo(console);
        const dom = new JSDOM(`<!DOCTYPE html><body></body>`);
        return dom;
    }
}
//# sourceMappingURL=chart.js.map