import { Regression } from "./regression.js";
export class PointChart {
    fillChart(config, basicChart) {
        let linearRegression = new Regression();
        let data = config.data.points;
        let svG = basicChart.svg;
        svG
            .selectAll("whatever")
            .data(data)
            .enter()
            .append("circle")
            .attr("cx", function (d) { return basicChart.axis.x.scale(d['x']); })
            .attr("cy", function (d) { return basicChart.axis[(d['yAxis'] === 'y' ? 'y' : 'y1')].scale(d['y']); })
            .attr("r", function (d) { return d['radius'] ? d.radius : 7; })
            .attr("fill", function (d) { return d['fill'] ? d.fill : 'black'; })
            .attr("stroke", function (d) { return d['stroke'] ? d.stroke : 'none'; })
            .attr("opacity", function (d) { return 0.5; });
        if (config.chart.regression && config.chart.regression.type === 'linear') {
            linearRegression.getLinearRegression(basicChart, config);
        }
        else if (config.chart.regression && config.chart.regression.type === 'quad') {
            linearRegression.getQuadRegression(basicChart, config);
        }
        else if (config.chart.regression && config.chart.regression.type === 'loess') {
            linearRegression.getLoessRegression(basicChart, config);
        }
        else if (config.chart.regression && config.chart.regression.type === 'poly') {
            linearRegression.getPolyRegression(basicChart, config);
        }
    }
}
//# sourceMappingURL=pointchart.js.map