export class ParserService {
    parseConfig(configOld) {
        if (typeof configOld['data'] === 'string') {
            configOld = JSON.parse(configOld['data']);
        }
        let result = {
            chart: undefined,
            data: undefined,
            axis: {
                x: undefined,
                y: undefined,
                y1: undefined
            },
            names: configOld.data.names
        };
        const chartConf = {
            type: configOld['charttype'],
            width: configOld['size']['width'],
            height: configOld['size']['height'],
            fontSize: configOld["font"]['size']["label"],
            margin: {
                top: 10,
                right: 80,
                bottom: 20,
                left: 10
            },
            regression: null,
            colorPalette: configOld.color.pattern,
            legend: configOld.legend
        };
        if (chartConf.legend && !chartConf.legend.type) {
            chartConf.legend.type = "round";
        }
        let xAxis = {
            show: configOld['axis']['x']['show'],
            min: 0,
            max: 6,
            tickCount: null,
            domain: ["0", "1", "2", "3", "4", "5", "6", "7"]
        };
        const y = {
            show: configOld['axis']['y']['show'],
            min: configOld['axis']['y']['min'],
            // max: 420000,
            max: configOld['axis']['y']['max'],
            tickCount: configOld['axis']['y']['tick']['count'],
            domain: []
        };
        const y1 = {
            show: false,
            min: null,
            max: null,
            tickCount: null,
            domain: []
        };
        result.data = configOld["data"]["columns"];
        result.data = [
            ["group", "1", "2", "3", "4", "5", "6", "7", "8"],
            ...configOld.data.columns
        ];
        result.data = [
            ["group", "1", "2"],
            ['WERT1', 10000, 8000],
            ['WERT2', 1000, 2000]
        ];
        let res = [["group", ...configOld.data.namesOrder]];
        for (let x = 1; x < result.data[0].length; x++) {
            let group = [result.data[0][x]];
            for (let y = 1; y < result.data.length; y++) {
                group.push(result.data[y][x]);
            }
            res.push(group);
        }
        result.data = res;
        /* Gruppen für X-Achse Definieren, das muss an erste stelle der werte Arrays stehen
        * categories = ["group", "WERT1", "WERT2", "WERT3", "MKV1", "MKV2"]
        */
        let parsedData = [];
        let categories = ["group", ...configOld.data.namesOrder];
        for (let index = 0; index < categories.length; index++) {
            if (!categories[index]) {
                categories[index] = index + '';
            }
        }
        parsedData.push(categories);
        for (let index = 1; index < configOld.data.columns[0].length; index++) {
            let group = [index + ''];
            for (let cat = 1; cat < categories.length; cat++) {
                let g = configOld.data.columns.find((col) => col[0] == categories[cat]);
                if (g) {
                    group.push(g[index]);
                }
            }
            parsedData.push(group);
        }
        result.data = parsedData;
        const groups = [];
        for (let index = 1; index < result.data.length; index++) {
            groups.push(result.data[index][0]);
        }
        xAxis.domain = groups;
        result.chart = chartConf;
        result.axis.x = xAxis;
        result.axis.y = y;
        result.axis.y1 = y1;
        return result;
    }
}
//# sourceMappingURL=config.parser.service.js.map