import { d3 } from "d3";
var d3_locale_deDE = d3.locale({
    "decimal": ",",
    "thousands": ".",
    "grouping": [3],
    // "currency" : [ "", chartData.axis.y.tick.unit],
    "dateTime": "%a %b %e %X %Y",
    "date": "%d. %m. %Y",
    "time": "%H:%M:%S",
    "periods": ["AM", "PM"],
    "days": ["Sonnatg", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"],
    "shortDays": ["So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"],
    "months": ["Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober",
        "November", "Dezember"],
    "shortMonths": ["Jan", "Feb", "Mer", "Apr", "Mai", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dez"]
});
d3.format = d3_locale_deDE.numberFormat;
window.d3 = d3;
/*
 * GAUGE LABEL FORMAT
 */
if (chartData.charttype === 'gauge') {
    console.log("gauge");
    if (chartData.gauge.label.percent !== undefined
        && chartData.gauge.label.percent === false) {
        chartData.gauge.label.format = function (value, ratio) {
            return d3.format(",.0f")(value);
        };
    }
    else {
        chartData.gauge.label.format = function (value, ratio) {
            return d3.format("%,.0f")(ratio);
        };
    }
}
/*
 * MIN / MAX
 */
/*
 * Y-Achse
 */
chartData.axis.y.min = chartData.axis.y.min === '' ? null : chartData.axis.y.min;
chartData.axis.y.max = chartData.axis.y.max === '' ? null : chartData.axis.y.max;
if ((chartData.axis.y.min !== undefined && chartData.axis.y.min !== null)
    || (chartData.axis.y.max !== undefined && chartData.axis.y.max !== null)) {
    chartData.axis.y.padding = {};
}
if (chartData.axis.y.min !== undefined && chartData.axis.y.min !== null) {
    chartData.axis.y.padding.bottom = 0;
}
if (chartData.axis.y.max !== undefined && chartData.axis.y.max !== null) {
    chartData.axis.y.padding.top = 0;
}
/*
 * Y2-Achse
 */
chartData.axis.y2.min = chartData.axis.y2.min === '' ? null : chartData.axis.y2.min;
chartData.axis.y2.max = chartData.axis.y2.max === '' ? null : chartData.axis.y2.max;
if ((chartData.axis.y2.min !== undefined && chartData.axis.y2.min !== null)
    || (chartData.axis.y2.max !== undefined && chartData.axis.y2.max !== null)) {
    chartData.axis.y2.padding = {};
}
if (chartData.axis.y2.min !== undefined && chartData.axis.y2.min !== null) {
    chartData.axis.y2.padding.bottom = 0;
}
if (chartData.axis.y2.max !== undefined && chartData.axis.y2.max !== null) {
    chartData.axis.y2.padding.top = 0;
}
/*
 * FORMAT: y2-Achse
 */
var unitFormat, f;
if (chartData.axis.y2.tick.format === "") {
    if (typeof chartData.axis.y2.tick.unit !== "undefined" && chartData.axis.y2.tick.unit.trim() !== '') {
        if (chartData.axis.y2.format !== undefined && chartData.axis.y2.format.length > 1) {
            unitFormat = function (d) {
                return d3.format(chartData.axis.y2.format)(d) + chartData.axis.y2.tick.unit;
            };
        }
        else if (chartData.axis.y2.tick.displayFormat !== undefined && chartData.axis.y2.tick.displayFormat.length > 1) {
            unitFormat = function (d) {
                return d3.format(",." + chartData.axis.y2.tick.displayFormat[1] + "f")(d) + chartData.axis.y2.tick.unit;
            };
        }
        else {
            unitFormat = function (d) {
                return d3.format(",.2f")(d) + chartData.axis.y2.tick.unit;
            };
        }
    }
    else {
        if (chartData.axis.y2.format !== undefined && chartData.axis.y2.format.length > 1) {
            unitFormat = d3.format(chartData.axis.y2.format);
        }
        else if (chartData.axis.y2.tick.displayFormat !== undefined && chartData.axis.y2.tick.displayFormat.length > 1) {
            unitFormat = d3.format(",." + chartData.axis.y2.tick.displayFormat[1] + "f");
        }
        else {
            unitFormat = d3.format(",.2f");
        }
    }
    chartData.axis.y2.tick.format = unitFormat;
}
else {
    try {
        eval("var f = " + chartData.axis.y.tick.format);
        if (typeof f === "function") {
            chartData.axis.y2.tick.format = f;
        }
        else if (typeof eval(chartData.axis.y2.tick.format) === "function") {
            chartData.axis.y2.tick.format = eval(chartData.axis.y2.tick.format);
        }
    }
    catch (e) {
        console.log(e);
        chartData.axis.y2.tick.format = '';
    }
}
/*
 * FORMAT: y-Achse
 */
if (chartData.axis.y.tick.format === "") {
    if (typeof chartData.axis.y.tick.unit !== "undefined" && chartData.axis.y.tick.unit.trim() !== '') {
        if (chartData.axis.y.format !== undefined && chartData.axis.y.format.length > 1) {
            unitFormat = function (d) {
                return d3.format(chartData.axis.y.format)(d) + chartData.axis.y.tick.unit;
            };
        }
        else if (chartData.axis.y.tick.displayFormat !== undefined && chartData.axis.y.tick.displayFormat.length > 1) {
            unitFormat = function (d) {
                return d3.format(",." + chartData.axis.y.tick.displayFormat[1] + "f")(d) + chartData.axis.y.tick.unit;
            };
        }
        else {
            unitFormat = function (d) {
                return d3.format(",.2f")(d) + chartData.axis.y.tick.unit;
            };
        }
    }
    else {
        if (chartData.axis.y.format !== undefined && chartData.axis.y.format.length > 1) {
            unitFormat = d3.format(chartData.axis.y.format);
        }
        else if (chartData.axis.y.tick.displayFormat !== undefined && chartData.axis.y.tick.displayFormat.length > 1) {
            unitFormat = d3.format(",." + chartData.axis.y.tick.displayFormat[1] + "f");
        }
        else {
            unitFormat = d3.format(",.2f");
        }
    }
    chartData.axis.y.tick.format = unitFormat;
}
else {
    try {
        eval("var f = " + chartData.axis.y.tick.format);
        if (typeof f === "function") {
            chartData.axis.y.tick.format = f;
        }
        else if (typeof eval(chartData.axis.y.tick.format) === "function") {
            chartData.axis.y.tick.format = eval(chartData.axis.y.tick.format);
        }
    }
    catch (e) {
        console.log(e);
        chartData.axis.y.tick.format = '';
    }
}
/*
 * FORMAT: x-Achse
 */
try {
    if (chartData.axis.x.format !== undefined && chartData.axis.x.format.length > 1) {
        chartData.axis.x.tick.format = d3.format(chartData.axis.x.format);
    }
    else if (chartData.axis.x.tick.displayFormat !== undefined && chartData.axis.x.tick.displayFormat.length > 1) {
        chartData.axis.x.tick.format = d3.format(",." + chartData.axis.x.tick.displayFormat[1] + "f");
    }
    else {
        if (chartData.axis.x.tick.format !== "") {
            eval("var f = " + chartData.axis.x.tick.format);
            if (typeof f === "function") {
                chartData.axis.x.tick.format = f;
            }
            else if (typeof eval(chartData.axis.x.tick.format) === "function") {
                chartData.axis.x.tick.format = eval(chartData.axis.x.tick.format);
            }
        }
    }
}
catch (e) {
    console.log(e);
    chartData.axis.x.tick.format = '';
}
function getD3Format(format) {
    var d3Format;
    switch (format[0]) {
        case 'N':
            d3Format = d3.format(",."
                + parseInt(format.substring(1))
                + "f");
            break;
        case 'P':
            // d3Format = d3.format("%,." + n + "f");
            d3Format = function (v) {
                return v === null ? '' : v.toFixed(parseInt(format.substring(1))) + "%";
            };
            break;
        default:
            d3Format = d3.format(",.0f");
            break;
    }
    return d3Format;
}
/*
 * FORMAT: labels
 */
if (typeof chartData.data.labels.format !== 'undefined') {
    for (var i in chartData.data.labels.format) {
        var format = chartData.data.labels.format[i];
        chartData.data.labels.format[i] = getD3Format(format);
    }
}
if (typeof chartData.data.bubbleLabels !== 'undefined') {
    if (chartData.data.bubbleLabels.x !== false) {
        chartData.data.bubbleLabels.x = getD3Format(chartData.data.bubbleLabels.x);
    }
    if (chartData.data.bubbleLabels.y !== false) {
        chartData.data.bubbleLabels.y = getD3Format(chartData.data.bubbleLabels.y);
    }
    if (chartData.data.bubbleLabels.v !== false) {
        chartData.data.bubbleLabels.v = getD3Format(chartData.data.bubbleLabels.v);
    }
}
chartData.data.labels.default = d3.format(",.2f");
for (var i in { 'pie': 0, 'donut': 0, 'gauge': 0 }) {
    if (typeof chartData[i] !== "undefined") {
        if (chartData[i].label.percent !== true) {
            chartData[i].label.format = unitFormat;
            //} else {
            //delete chartData[i].label.format;
        }
    }
}
if (typeof chartData.grid !== "undefined" &&
    typeof chartData.grid.y !== "undefined" &&
    typeof chartData.grid.y.linevalues !== "undefined") {
    delete chartData.grid.y.linevalues;
}
chartData.onrendered = function () {
    window.svgString = d3.select("#svg").html();
    // IMPORTANT: Don't remove 'console.info('onrendered');'
    console.info('onrendered');
};
var svg = c3.generate(chartData);
//# sourceMappingURL=chart_c3_jsdom_scritp.js.map