var Imagebuilder = function () {
};
Imagebuilder.prototype.build = function (svgfile, config, deleteSvgfile) {
    console.log(svgfile, config, deleteSvgfile);
    var im = require('imagemagick');
    var img;
    im.resize({
        srcPath: svgfile.filename,
        dstPath: 'download/radar-' + config.uuid + '.' + config.doctype,
        width: config.w,
        height: config.h,
        format: config.doctype,
        filter: 'Lagrange',
        //		quality : 1,
        sharpening: 0.2,
        strip: false,
        customArgs: [
            // '-transparent', 'white',
            '-unsharp', '2x0.5', '-quality', '100'
        ]
    }, function (err, stdout, stderr) {
        if (err) {
            console.log('--- imagebuilder ----');
            console.log(err);
            throw err;
        }
        img = {
            'filename': 'download/radar-' + config.uuid + '.' + config.doctype,
            'name': 'radar.' + config.doctype
        };
    });
    require('deasync').loopWhile(function () {
        return img === undefined;
    });
    if (deleteSvgfile) {
        require('fs').unlinkSync(svgfile.filename);
    }
    return img;
};
module.exports = new Imagebuilder();
//# sourceMappingURL=imagebuilder.js.map