var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import express from "express";
const routerV0 = express.Router();
import * as chartCIS from './private/module/chartcis/chartcis.js';
var branchVersion = new Date().toLocaleString();
var serverUrl = '';
// define a route handler for the default home page
routerV0.post("/", (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    var data;
    try {
        data = JSON.parse(req.body.data);
    }
    catch (e) {
        data = req.body;
    }
    var chartcis = chartCIS;
    var dataStr = "<br/><pre>" + JSON.stringify(data, null, 4) + "</pre>";
    if (typeof data.data !== "object") {
        res.send('Inavlid JSON!' + dataStr);
        return;
    }
    else if (data.config === undefined) {
        res.send('Invalid chart configuration: parameter "config" is missing!' + dataStr);
        return;
    }
    else if (data.config.doctype === undefined) {
        res.send('Invalid chart configuration: parameter "config.doctype" is missing!' + dataStr);
        return;
    }
    else if (data.config.charttype === undefined) {
        res.send('Invalid chart configuration: parameter "config.charttype" is missing!' + dataStr);
        return;
    }
    data.config['serverVersion'] = branchVersion;
    var newchart = yield chartcis.build(data, serverUrl, req.body.data);
    if (newchart !== undefined && data.config.doctype !== 'html') {
        if (newchart['svg'] !== undefined) {
            res.send(newchart['svg']);
        }
        else {
            chartcis.download(res, newchart);
        }
    }
    else {
        res.send(newchart);
    }
    data = null;
    dataStr = null;
    newchart = null;
    chartcis = null;
}));
export default routerV0;
//# sourceMappingURL=router.v0.js.map