import jsdom from "jsdom";
import { BasicChartService } from "../chart/basicchart.service.js";
import { BarChart } from "../chart/charttypes/barchart.js";
import { GaugeChart } from "../chart/charttypes/gaugechart.js";
import { PointChart } from "../chart/charttypes/pointchart.js";
import { RadarChart } from "../chart/charttypes/radarchart.js";
import { Regression } from "../chart/charttypes/regression.js";
const { JSDOM } = jsdom;
export class Chart {
    constructor() {
        this.basicChartService = new BasicChartService();
        this.regression = new Regression();
    }
    getPointChart(config) {
        const dom = this.createDom(config);
        let basicChart;
        basicChart = this.basicChartService.getBasicChart(dom.window.document, config);
        let pointChart = new PointChart();
        pointChart.fillChart(config, basicChart);
        return dom.serialize();
    }
    getBarChart(config) {
        console.log("bar chart");
        const dom = this.createDom(config);
        let basicChart;
        basicChart = this.basicChartService.getBasicChart(dom.window.document, config);
        let barChart = new BarChart();
        barChart.fillChart(config, basicChart);
        return dom.serialize();
    }
    getGaugeChart(config) {
        const dom = this.createDom(config);
        let basicChart;
        basicChart = this.basicChartService.getBasicChart(dom.window.document, config);
        let gaugeChart = new GaugeChart();
        gaugeChart.fillChart(config, basicChart);
        return dom.serialize();
    }
    getRadarChart(config) {
        const dom = this.createDom(config);
        let basicChart;
        basicChart = this.basicChartService.getBasicChart(dom.window.document, config);
        let radar = new RadarChart();
        radar.fillChart(config, basicChart);
        return dom.serialize();
    }
    createDom(config) {
        const padding = `padding: ${config.chart.margin.top}px ${config.chart.margin.right}px ${config.chart.margin.bottom}px ${config.chart.margin.left}px `;
        const html = `<!DOCTYPE html>
        <body>
        <div style="display: flex;">
            <div id="chart" style=""></div>
            <div id="legendRight"></div>
        </div>
        <div id="legendBottom">
        </div>
        </body>`;
        var virtualConsole = new jsdom.VirtualConsole().sendTo(console);
        const dom = new JSDOM(html, { pretendToBeVisual: true });
        return dom;
    }
}
//# sourceMappingURL=chart.js.map