var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import express from "express";
import { Chart } from "./chart.js";
import { Worker } from "worker_threads";
import { ParserService } from "../library/parser/config.parser.service.js";
const router = express.Router();
const parser = new ParserService();
// define a route handler for the default home page
router.post("/point", (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    console.log("endpoint");
    const config = req.body;
    getChart(res, config);
}));
router.post("/gauge", (req, res) => {
    const config = req.body;
    getChart(res, config);
});
router.post("/bar", (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    console.log("bar");
    const config = parser.parseConfig(req.body);
    getChart(res, config);
}));
router.post("/radar", (req, res) => {
    const config = req.body;
    getChart(res, config);
});
function getChart(res, config) {
    const chart = new Chart();
    let c;
    switch (config.chart.type) {
        case 'point':
            c = chart.getPointChart(config);
            break;
        case 'gauge':
            c = chart.getGaugeChart(config);
            break;
        case 'bar':
            c = chart.getBarChart(config);
            break;
        case 'radar':
            c = chart.getRadarChart(config);
            break;
        default:
            break;
    }
    res.send(c);
    return;
    const worker = new Worker("./worker.js", { workerData: { config: config } });
    worker.once("message", (result) => {
        res.status(200).send(result);
    });
}
export default router;
//# sourceMappingURL=router.v1.js.map