import { parentPort, workerData } from "worker_threads";
import { Chart } from "./chart.js";
parentPort.postMessage(getChart(workerData.config));
function getFib(num) {
    if (num === 0) {
        return 0;
    }
    else if (num === 1) {
        return 1;
    }
    else {
        return getFib(num - 1) + getFib(num - 2);
    }
}
function getChart(config) {
    const chart = new Chart();
    let c;
    switch (config.chart.type) {
        case 'point':
            c = chart.getPointChart(config);
            break;
        case 'gauge':
            c = chart.getGaugeChart(config);
            break;
        case 'bar':
            c = chart.getBarChart(config);
            break;
        case 'radar':
            c = chart.getRadarChart(config);
            break;
        default:
            break;
    }
    return c;
}
//# sourceMappingURL=worker.js.map