import { Chart } from "../../model/chart";
import { Config } from "../../model/config";
import { Regression } from "./regression.js";

export class PointChart {


    fillChart(config: Config, basicChart: Chart) {
        let linearRegression = new Regression();

        let data: any[] = config.data.points;
        let svG = basicChart.svg;
        svG
            .selectAll("whatever")
            .data(data)
            .enter()
            .append("circle")
            .attr("cx", function(d: any){ return basicChart.axis.x.scale(d['x']) })
            .attr("cy", function(d: any){ return basicChart.axis[(d['yAxis'] === 'y'? 'y' : 'y1')].scale(d['y']) })
            .attr("r", function(d: any){ return d['radius'] ? d.radius : 7})
            .attr("fill", function(d: any){ return d['fill'] ? d.fill : 'black'})
            .attr("stroke", function(d: any){ return d['stroke'] ? d.stroke : 'none'})
            .attr("opacity", function(d: any) { return 0.5 });


            if (config.chart.regression && config.chart.regression.type === 'linear') {
                linearRegression.getLinearRegression(basicChart, config)
            } else if (config.chart.regression && config.chart.regression.type === 'quad') {
                linearRegression.getQuadRegression(basicChart, config);
            } else if (config.chart.regression && config.chart.regression.type === 'loess') {
                linearRegression.getLoessRegression(basicChart, config);
            } else if (config.chart.regression && config.chart.regression.type === 'poly') {
                linearRegression.getPolyRegression(basicChart, config);
            }
    }

}