import express from "express";
import bodyParser from "body-parser";
import { Chart } from "./server/chart.js";
import { Config } from "./model/config.js";

import router from './server/router.v1.js';


const jsonParser = bodyParser.json(); 

const app = express();
app.use(bodyParser.urlencoded({ extended: true }));
app.use(jsonParser)
const port = 4040; // default port to listen


// enable CORS
app.use(function (req, res, next) {
    res.header("Access-Control-Allow-Origin", "*");
    res.header("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept");
    next();
});


app.use('/v1' , router)



// start the Express server
app.listen( port, () => {
    console.info( `server started at http://localhost:${ port }` );
} );

