export interface Chartconfig {
    type: CHARTTYPE;
    width: number;
    height: number;
    fontSize: number;
    strokeWidth?: number;
    margin: { top: number, right: number, bottom: number, left: number };
    showGrid?: boolean;
    regression: null | {
        type: 'linear' | 'quad' | 'loess' | 'poly',
        bandwidth?: number,
        order?: number,
        stroke: string,
        width: string
    },
    radarConfig?: {
        radialScale: any
    },
    colorPalette?: string[];
    legend?: {
        show: boolean,
        position: "bottom" | "right",
        values: boolean,
        type: "round" | "square"
    }
}

export type CHARTTYPE = 'bar' | 'line' | 'point' | 'gauge' | 'radar'