import express, { Request, Response } from "express";
import { Chart } from "./chart.js";
import { Config } from "../model/config";
import { Worker } from "worker_threads"
import { ParserService } from "../library/parser/config.parser.service.js"
const router = express.Router()

const parser = new ParserService();


// define a route handler for the default home page
router.post( "/point", async ( req: any, res: Response ) => {
    console.log("endpoint")
    const config: Config = req.body
    getChart(res, config);

} );




router.post( "/gauge", ( req: any, res: any ) => {
    const config: Config = req.body
    getChart(res, config);
} );


router.post( "/bar", async ( req: any, res: any ) => {
    console.log("bar")
    const config: Config = parser.parseConfig(req.body);
    getChart(res, config);
} );

router.post( "/radar", ( req: Request, res: any ) => {

    const config: Config = req.body
    getChart(res, config);
} );

function getChart(res: Response, config: Config): any {
    const chart = new Chart();
    let c;
    switch (config.chart.type) {
        case 'point':
            c =  chart.getPointChart(config);
            break;
        case 'gauge':
            c = chart.getGaugeChart(config);
            break;
        case 'bar':
            c = chart.getBarChart(config);
            break;
        case 'radar':
            c = chart.getRadarChart(config);
            break;
        default:
            break;
    }
    res.send(c);
    return;
    const worker = new Worker("./worker.js", {workerData: {config: config}});
    worker.once("message", (result: any) => {
        res.status(200).send(result);
    });

}

export default router;