import {parentPort, workerData} from "worker_threads";
import { Chart } from "./chart.js";
import { Config } from "../model/config";

parentPort.postMessage(getChart(workerData.config))

function getFib(num: any): any {
    if (num === 0) {
      return 0;
    }
    else if (num === 1) {
      return 1;
    }
    else {
      return getFib(num - 1) + getFib(num - 2);
    }
}

function getChart(config: Config) {
    const chart = new Chart();
    parentPort.postMessage("get bar chart")
    parentPort.postMessage(console.log("get bar chart"))
    let c;
    switch (config.chart.type) {
        case 'point':
            c =  chart.getPointChart(config);
            break;
        case 'gauge':
            c = chart.getGaugeChart(config);
            break;
        case 'bar':
            parentPort.postMessage("get bar chart")
            c = chart.getBarChart(config);
            break;
        case 'radar':
            c = chart.getRadarChart(config);
            break;
        default:
            break;
    }
    return c;
}